<?

 /*
*******************************
 IP-SYMCON Event Scripting
*******************************
File     : KS300_Regenerfassung.ips.php
Trigger  : Regenzaehler_neu
Interval : OnUpdate
Author   : HJH
Date     : 25.05.07

Das Skript wir durch die Integer Variable "Regenzaehler_neu" OnUpdate getriggert.
"Regenzaehler_neu" ist der Zhlerstand, den die KS300 ca. alle 3 Minuten meldet.
*/



define("UMRECHNUNGSFAKTOR", 0.2469); // Faktor fr die Umrechnung der Wippenschlge in Millimeter



// aktuelle Werte einlesen
$rza = GetValueInteger("Regenzaehler_alt"); // vorausgegangene Messung
$rzn = GetValueInteger("Regenmenge"); // aktuelle Messung

// zur Fehlerbereinigung die unteren Nibbles vertauschen
$rzn = (($rzn & 0x00f0) >> 4)  // oberes  Nibble des LSB 4x rechts schieben (entspricht Division durch 16)
     + (($rzn & 0x000f) << 4); // unteres Nibble des LSB 4x links schieben  (entspricht Multiplikation mit 16)

// Zhlerstand abspeichern
SetValueInteger("Regenzaehler_alt", $rzn);

// Zhlerberlauf abfangen
if ($rza > $rzn) $rzn += 256;

// Zuwachs (Wippenschlge) seit der letzten Messung
$Zuwachs = $rzn - $rza;

// Berechnung der aktuellen Regenmenge in mm (entspricht l/m) fr den laufenden Tag
$lpd = GetValueFloat("mm_heute");
$lpd += $Zuwachs*UMRECHNUNGSFAKTOR;
SetValueFloat("mm_heute", $lpd);
?>
