<?
/*
FUNCTION: Baustein zum Auslesen von Daten aus einer S7

CHANGELOG:
13.03.2009 Gusenbauer
 + Erste funtionierendes Script

02.04.2009 Gusenbauer
 + Umbau auf Functionsscript

19.04.2009 Gusenbauer
 + TS_LAST_SUCCESSFULLY_READING eingefuehrt
   um auch in der Visualisierung den TS anzeigen zu koennen
   
*/


//** CONFIG ******************************************************************
$S7_ParentInstanz_ID = 53209 ;
$S7_Instanz_ID   = 19212  ;

$S7_Path  = "S7/PALETTENNUMMERN/";    //Pfad der


//index0   = VARIABLENBEZEICHNUNG in IPS
//index1.0 = TYP          (0=bit, 1=byte, 2=word, 3=dword,
//                         4=ShortInt, 5=SmallInt, 6=Integer, 7=Real)
//index1.1 = AREA         (0=SystemInfo, 1=SystemFlags,
//                         2=AnalogInput CPU200, 3=AnalogOutput CPU200,
//                         4=Input, 5=Output, 6=Flags, 7=Datablock,
//                         8=InstanzDaten, 9=LokaleDaten, 10=UnknownedArea
//                         11=Zaehler, 12=Timer, 13=PEW/PAW)
//index1.2 = AREAADDRESS  (Baustein)
//index1.3 = ADDRES       (StartByte)
//index1.4 = BIT          (Bit = wird nur bei TYP=0 verarbeitet)
//index1.5 = CONVERT-S7-Value vor schreiben auf die IPS-Variable
//                        (0=unverndert, 1=Dec2Hex, 2=Hex2Dec)

$S7_VAR_IDs = array("M0.1"                    => array(0,6,0,0,1,0),
                    "PALETTE_PALETTENWAGEN_1" => array(2,7,275,30,0,0),
                    "PALETTE_MASCHINE_1"      => array(2,7,275,50,0,0),
			 			  "PALETTE_MASCHINE_2"      => array(2,7,275,70,0,0),
						  "PALETTE_RUESTPLATZ_1"    => array(2,7,275,90,0,0),
						  "PALETTE_RUESTPLATZ_2"    => array(2,7,275,110,0,0),
						  "PALETTE_PUFFERPLATZ_1"   => array(2,7,275,130,0,0),
						  "PALETTE_PUFFERPLATZ_2"   => array(2,7,275,150,0,0),
						  "PALETTE_PUFFERPLATZ_3"   => array(2,7,275,170,0,0),
						  "PALETTE_PUFFERPLATZ_4"   => array(2,7,275,190,0,0),
						  "PALETTE_PUFFERPLATZ_5"   => array(2,7,275,210,0,0),
						  "PALETTE_PUFFERPLATZ_6"   => array(2,7,275,230,0,0),
						  "SCHUTZBEREICH_RP1_AKTIV" => array(0,4,0,34,6,0),
						  "SCHUTZBEREICH_RP2_AKTIV" => array(0,4,0,41,1,0));


$S7_Path1  = "S7/0011257400_BETRIEBSSTUNDEN_37034P";  //Pfad der Hirachieebene

//index0   = VARIABLENBEZEICHNUNG in IPS
//index1.0 = TYP          (0=bit, 1=byte, 2=word, 3=dword)
//index1.1 = AREA         (4=input, 5=output, 6=flags, 7=datablock)
//index1.2 = AREAADDRESS  (Baustein)
//index1.3 = ADDRES       (StartByte)
//index1.4 = BIT          (Bit = wird nur bei TYP=0 verarbeitet)
//index1.5 = CONVERT-S7-Value vor schreiben auf die IPS-Variable
//                        (0=unverndert, 1=Dec2Hex, 2=Hex2Dec)

$S7_VAR_IDs1 = array("M0.1"                    => array(0,6,0,0,1,0),
                    "Q3_HOUR"                 => array(2,7,186,4,0,0),
			 			  "Q3_SECOND"               => array(2,7,186,2,0,0),
                    "Q4_HOUR"                 => array(2,7,186,8,0,0),
			 			  "Q4_SECOND"               => array(2,7,186,6,0,0),

                    "PROGRAMMLAUFZEIT_HOUR"   => array(2,7,186,36,0,0),
			 			  "PROGRAMMLAUFZEIT_SECOND" => array(2,7,186,34,0,0),

                    "ZAEHLER_TEILTRANSPORTE"  => array(2,7,186,138,0,0),

                    "SYSTIME_RESETGROUP_1_YEAR"   => array(1,7,186,182,0,2),
                    "SYSTIME_RESETGROUP_1_MONTH"  => array(1,7,186,183,0,2),
                    "SYSTIME_RESETGROUP_1_DAY"    => array(1,7,186,184,0,2),
                    "SYSTIME_RESETGROUP_1_HOUR"   => array(1,7,186,185,0,2),
                    "SYSTIME_RESETGROUP_1_MINUTE" => array(1,7,186,186,0,2),

                    "SYSTIME_RESETGROUP_2_YEAR"   => array(1,7,186,190,0,2),
                    "SYSTIME_RESETGROUP_2_MONTH"  => array(1,7,186,191,0,2),
                    "SYSTIME_RESETGROUP_2_DAY"    => array(1,7,186,192,0,2),
                    "SYSTIME_RESETGROUP_2_HOUR"   => array(1,7,186,193,0,2),
                    "SYSTIME_RESETGROUP_2_MINUTE" => array(1,7,186,194,0,2),

                    "SYSTIME_RESETGROUP_3_YEAR"   => array(1,7,186,198,0,2),
                    "SYSTIME_RESETGROUP_3_MONTH"  => array(1,7,186,199,0,2),
                    "SYSTIME_RESETGROUP_3_DAY"    => array(1,7,186,200,0,2),
                    "SYSTIME_RESETGROUP_3_HOUR"   => array(1,7,186,201,0,2),
                    "SYSTIME_RESETGROUP_3_MINUTE" => array(1,7,186,202,0,2));
                    
//****************************************************************************
// Ab hier den eigentlichen Verarbeitungscode einfuegen
//****************************************************************************

include_once ('./common_function.php');
include_once ('./s7_function.php');

//S7-Verbindung aufbauen wenn nicht besteht
while (S7_GetOpen($S7_ParentInstanz_ID) == false)
		{
		$S7_connect = S7_SetOpen($S7_ParentInstanz_ID,true);
		IPS_ApplyChanges($S7_ParentInstanz_ID);

		echo $S7_connect . "\r\n";
		IPS_Sleep(1000);
		$test = $test + 1;
		if ($test >=10)
			{
			//Scripttrigger auf Fehler setzen
         SetValueInteger("SCRIPTTRIGGER_37004",999);
         echo "TIMEOUT BEI CONNECT mit ID:" . $S7_ParentInstanz_ID;
			exit;
			}
		}

$ret = S7_VAR_IDs_READ($S7_Instanz_ID,$S7_Path,$S7_VAR_IDs);


if ($ret >= 1)
	{
		//Verbindung zur PLC schliessen, wird beim neachsten Aufruf
		//wieder aufgebaut !!
		$S7_connect = S7_SetOpen($S7_ParentInstanz_ID,false);
		IPS_ApplyChanges($S7_ParentInstanz_ID);
      echo "Verbindung getrennt !!! ID:" . $S7_ParentInstanz_ID;
      exit;
	}
else
	{
	 SetValueStringByName($S7_Path . "TS_LAST_SUCCESSFULLY_READING",date("d.m.Y H:i:s"));
	}

if (GetValueInteger("SCRIPTTRIGGER_37034P") == 1)
	{

    //Daten von S7-lesen
    S7_VAR_IDs_READ($S7_Instanz_ID,$S7_Path1,$S7_VAR_IDs1);

    //Scripttrigger wieder zuruecksetzen
    SetValueInteger("SCRIPTTRIGGER_37034P",0);
	}


?>