<?
// Test ModBus RTU Abfrage DRT-301M

// hier ein Beispiel wie die Funktion 03 abluft
// Read Holding Registers (FC=03)

// Request

// This command is requesting the content of analog output holding registers # 40108 to
// 40110 from the slave device with address 17.

// 11 03 006B 0003 7687

// 11: The Slave Address (17 = 11 hex)
// 03: The Function Code (read Analog Output Holding Registers)
// 006B: The Data Address of the first register requested. (40108-40001 = 107 = 6B hex)
// 0003: The total number of registers requested. (read 3 registers 40108 to 40110)
//7687: The CRC (cyclic redundancy check) for error checking.

//Response

// 11 03 06 AE41 5652 4340 49AD

// 11: The Slave Address (17 = 11 hex)
// 03: The Function Code (read Analog Output Holding Registers)
// 06: The number of data bytes to follow (3 registers x 2 bytes each = 6 bytes)
// AE41: The contents of register 40108
// 5652: The contents of register 40109
// 4340: The contents of register 40110
// 49AD: The CRC (cyclic redundancy check).

$ComID = 59425;
//01 03 00 10 00 02 C5 CE
//68 00 00 00 00 00 00 68 01 02 44 E9 00 16
$Adress_Slave      = "\x01";
$Function          = "\x03";
$Dataadress        = "\x00\x10"; // 40001-40001=0=00 hex
$Total_Number      = "\x00\x02";
for($count = 1; $count < 256; $count++)
  {
    IPS_Sleep(50);
    if (chr($count)<> ("\x68"))
    {
   $FC03 =chr($count).$Function.$Dataadress.$Total_Number;  	// Datenframe
  $CRC16 = GetCRC16 ($FC03);           								// Checksumme berechnen
  $CRC16str = chr($CRC16&0xff).chr($CRC16>>8);    					// Hi-Lo-Byte tauschen
//$CRC16str = chr($CRC16>>8);
$Senddata = "\x00".$FC03.$CRC16str;                      				// Checksumme an Datenframe bergeben
//$Senddata = $FC03."\x19\x16";
  COMPort_SendText($ComID, $Senddata);               				// Datenframe ber Comport senden
}
}


function GetCRC16($s)
// CRC16 Berechnung fr ModBus RTU
// Modifizierte Quelle von www.gossenmetrawatt.com/resources/me/sineax_cam/modbus_basics_d.pdf
// Die Version von HJH aus dem IP-Symcon Forum habe ich nicht zum laufen gebracht.
// Getestet einem ModBus-Slave Simulator von www.simplymodbus.ca
// Unter www.simplymodbus.ca gibt es auch eine Excel-Tabelle die die Prfsumme berechnet
//
// Thomas Unger 23.02.2010
//
{
 $crc = 0xffff; 			// Startwert
 $Poly16 = 0xA001; 		// Polynom fr Modbus RTU

for ($count=0; $count<strlen($s); $count++)
 {
	$crc = (($crc^ ord($s[$count])) | 0xFF00) & ($crc | 0x00FF);
   for ($i=0; $i<8; $i++)
  		{
  		$LSB=($crc & 0x0001);
  		$crc=$crc/2;
  		if ($LSB) $crc=$crc^$Poly16;
  		}
 }
 return $crc;
}

?>