<?
/*
FUNCTION: Baustein zum Auslesen von Daten aus einer S7

CHANGELOG:
13.03.2009 Gusenbauer
 + Erste funtionierendes Script

02.04.2009 Gusenbauer
 + Umbau auf Functionsscript

10.04.2009 Gusenbauer
 + Hinzufuegen der weiteren Zeiten (Kuehlmittel, Zentriefuge,...)
 
*/


//** CONFIG ******************************************************************
$S7_ParentInstanz_ID = 21904 ;
$S7_Instanz_ID       = 20106  ;

$S7_Path  = "S7_37034/0011257402_BETRIEBSSTUNDEN_37034/";    //Pfad der Hierachieebene

//index0   = VARIABLENBEZEICHNUNG in IPS
//index1.0 = TYP          (0=bit, 1=byte, 2=word, 3=dword,
//                         4=ShortInt, 5=SmallInt, 6=Integer, 7=Real)
//index1.1 = AREA         (0=SystemInfo, 1=SystemFlags,
//                         2=AnalogInput CPU200, 3=AnalogOutput CPU200,
//                         4=Input, 5=Output, 6=Flags, 7=Datablock,
//                         8=InstanzDaten, 9=LokaleDaten, 10=UnknownedArea
//                         11=Zaehler, 12=Timer, 13=PEW/PAW)
//index1.2 = AREAADDRESS  (Baustein)
//index1.3 = ADDRES       (StartByte)
//index1.4 = BIT          (Bit = wird nur bei TYP=0 verarbeitet)
//index1.5 = CONVERT-S7-Value vor schreiben auf die IPS-Variable
//                        (0=unverndert, 1=Dec2Hex, 2=Hex2Dec)

$S7_VAR_IDs = array("M0.1"                            => array(0,6,0,0,1,0),
                    "AGG01_HOUR"                      => array(2,7,186,4,0,0),
			 			  "AGG01_SECOND"                    => array(2,7,186,2,0,0),
                    "AGG02_HOUR"                      => array(2,7,186,8,0,0),
			 			  "AGG02_SECOND"                    => array(2,7,186,6,0,0),
                    "AGG11_HOUR"                      => array(2,7,186,12,0,0),
			 			  "AGG11_SECOND"                    => array(2,7,186,10,0,0),
                    "AGG12_HOUR"                      => array(2,7,186,16,0,0),
			 			  "AGG12_SECOND"                    => array(2,7,186,14,0,0),
                    "AGG13_HOUR"                      => array(2,7,186,20,0,0),
			 			  "AGG13_SECOND"                    => array(2,7,186,18,0,0),
                    "AGG03_HOUR"                      => array(2,7,186,24,0,0),
			 			  "AGG03_SECOND"                    => array(2,7,186,20,0,0),

                    "PROGRAMMLAUFZEIT_HOUR"           => array(2,7,186,36,0,0),
			 			  "PROGRAMMLAUFZEIT_SECOND"         => array(2,7,186,34,0,0),

                    "WECHSELZEIT_HOUR"                => array(2,7,186,40,0,0),
			 			  "WECHSELZEIT_SECOND"              => array(2,7,186,38,0,0),
                    "AAC_ATC_HOUR"                    => array(2,7,186,32,0,0),
			 			  "AAC_ATC_SECOND"                  => array(2,7,186,30,0,0),
                    "ATC_HOUR"                        => array(2,7,186,28,0,0),
			 			  "ATC_SECOND"                      => array(2,7,186,26,0,0),

                    "MASCHINENSIGNAL_HOUR"            => array(2,7,186,64,0,0),
			 			  "MASCHINENSIGNAL_SECOND"          => array(2,7,186,62,0,0),

                    "ABSAUGUNG_HOUR"                  => array(2,7,186,72,0,0),
			 			  "ABSAUGUNG_SECOND"                => array(2,7,186,70,0,0),
                    "SPAENNEFOERDER_2_HOUR"           => array(2,7,186,76,0,0),
			 			  "SPAENNEFOERDER_2_SECOND"         => array(2,7,186,74,0,0),
                    "KUEHLMITTELPUMPE_INTERN_HOUR"    => array(2,7,186,80,0,0),
			 			  "KUEHLMITTELPUMPE_INTERN_SECOND"  => array(2,7,186,78,0,0),
                    "KUEHLMITTELPUMPE_EXTERN_HOUR"    => array(2,7,186,84,0,0),
			 			  "KUEHLMITTELPUMPE_EXTERN_SECOND"  => array(2,7,186,82,0,0),
                    "KUEHLMITTELHEBEPUMPE_HOUR"       => array(2,7,186,88,0,0),
			 			  "KUEHLMITTELHEBEPUMPE_SECOND"     => array(2,7,186,86,0,0),
                    "ZENTRIEFUGE_HOUR"                => array(2,7,186,92,0,0),
			 			  "ZENTRIEFUGE_SECOND"              => array(2,7,186,90,0,0),
                    "OBERFLAEACHENABSAUGUNG_HOUR"     => array(2,7,186,96,0,0),
			 			  "OBERFLAEACHENABSAUGUNG_SECOND"   => array(2,7,186,94,0,0),

                    "SYSTIME_RESETGROUP_1_YEAR"       => array(1,7,186,182,0,2),
                    "SYSTIME_RESETGROUP_1_MONTH"      => array(1,7,186,183,0,2),
                    "SYSTIME_RESETGROUP_1_DAY"        => array(1,7,186,184,0,2),
                    "SYSTIME_RESETGROUP_1_HOUR"       => array(1,7,186,185,0,2),
                    "SYSTIME_RESETGROUP_1_MINUTE"     => array(1,7,186,186,0,2),

                    "SYSTIME_RESETGROUP_2_YEAR"       => array(1,7,186,190,0,2),
                    "SYSTIME_RESETGROUP_2_MONTH"      => array(1,7,186,191,0,2),
                    "SYSTIME_RESETGROUP_2_DAY"        => array(1,7,186,192,0,2),
                    "SYSTIME_RESETGROUP_2_HOUR"       => array(1,7,186,193,0,2),
                    "SYSTIME_RESETGROUP_2_MINUTE"     => array(1,7,186,194,0,2),

                    "SYSTIME_RESETGROUP_3_YEAR"       => array(1,7,186,198,0,2),
                    "SYSTIME_RESETGROUP_3_MONTH"      => array(1,7,186,199,0,2),
                    "SYSTIME_RESETGROUP_3_DAY"        => array(1,7,186,200,0,2),
                    "SYSTIME_RESETGROUP_3_HOUR"       => array(1,7,186,201,0,2),
                    "SYSTIME_RESETGROUP_3_MINUTE"     => array(1,7,186,202,0,2));


//****************************************************************************
// Ab hier den eigentlichen Verarbeitungscode einfuegen
//****************************************************************************

include_once ('./common_function.php');
include_once ('./s7_function.php');

//S7-Verbindung aufbauen
while (S7_GetOpen($S7_ParentInstanz_ID) == false)
		{
		$S7_connect = S7_SetOpen($S7_ParentInstanz_ID,true);
		IPS_ApplyChanges($S7_ParentInstanz_ID);

		echo $S7_connect . "\r\n";
		IPS_Sleep(1000);
		$test = $test + 1;
		if ($test >=10)
			{
			//Scripttrigger auf Fehler setzen
         SetValueInteger("SCRIPTTRIGGER_37034",999);
         echo "TIMEOUT BEI CONNECT mit ID:" . $S7_ParentInstanz_ID;
			exit;
			}
		}

//Daten von S7-lesen
S7_VAR_IDs_READ($S7_Instanz_ID,$S7_Path,$S7_VAR_IDs);

//Scripttrigger wieder zuruecksetzen
SetValueInteger("SCRIPTTRIGGER_37034",0);

//S7-Verbindung abbauen
S7_SetOpen($S7_ParentInstanz_ID,false);
IPS_ApplyChanges($S7_ParentInstanz_ID);

?>